<template>
	<div class="card" v-if="state === LegacyState.Migrated">
		<h3>Migration</h3>
		Successfully migrated <br>
		<div class="options">
			<button type="button" @click="state = LegacyState.Init" class="button">Return</button>
		</div>
	</div>
	<div class="card" v-else-if="state === LegacyState.Error">
		<h3>Error</h3>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</div>
	<div class="card" v-else-if="state === LegacyState.TooMany">
		<h3>Error</h3>
		<pre>You own too many accounts.</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</div>
	<div class="card" v-else-if="state === LegacyState.Exists">
		<h3>Migration</h3>
		This username is already in use. Please use a different username.
		<div class="options">
			<button type="button" @click="state = LegacyState.Migrate" class="button">Try again</button>
			<button type="button" @click="state = LegacyState.Init" class="button ghost">Cancel</button>
		</div>
	</div>
	<div class="card" v-else-if="state === LegacyState.Migrate">
		<h3>Migration</h3>
		Please choose a username for your new account:
		<form class="login" @submit.prevent="state = LegacyState.Migrate2">
			<br>
			<label for="username">username: </label>
			<input class="input" required v-focus name="username" id="username" ref="username" v-model="user.name" type="text" placeholder="ManaPlus username" minlength="4" maxlength="23" pattern="^[a-zA-Z0-9_]{4,23}$" title="4-23 characters, alphanumeric and underscores" />
			<br><br>
			<button type="submit" ref="submit" class="button prime">Confirm</button> &nbsp;
			<button type="button" @click="state = LegacyState.Init" class="button ghost">Cancel</button>
		</form>
	</div>
	<div class="card" v-else-if="state === LegacyState.Migrate2">
		<h3>Migration</h3>
		Please choose a password for your new account:
		<!-- TODO: check PwnedPasswords -->
		<form class="login" @submit.prevent="migrate">
			<br>
			<label for="password">password: </label>
			<input class="input" required v-focus name="password" id="password" ref="password" v-model="user.password" type="password" placeholder="new password" minlength="8" maxlength="30" pattern="^[^\s][^\t\r\n]{6,28}[^\s]$" title="8-30 characters" />
			<br><br>
			<button type="submit" ref="migrate" class="button prime">Confirm</button> &nbsp;
			<button type="button" @click="state = LegacyState.Init" class="button ghost">Cancel</button>
		</form>
	</div>
	<div class="card" v-else>
		<span>{{ acc.name }}</span>
		<ul>
				<li v-for="(char, id) in acc.chars" :key="id">{{ char.name }}</li>
		</ul>
		<div class="options" v-if="false">
			<!-- we'll want to enable this post-launch -->
			<button type="button" v-if="!manage" @click="manage = true" class="button">manage</button>
			<button type="button" v-if="manage" class="button">change username</button>
			<button type="button" v-if="manage" class="button">change password</button>
			<button type="button" v-if="manage" class="button">change email address</button>
			<button type="button" v-if="manage" class="button ghost">delete account</button>
		</div>
		<div class="options" v-else>
			<button type="button" v-if="acc.revoltId" disabled class="button ghost">already migrated</button>
			<button type="button" v-else @click="state = LegacyState.Migrate" class="button">Migrate to new server</button>
		</div>
	</div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator"

enum LegacyState {
	Init,     // initial state
	Migrate,  // migration (username)
	Migrate2, // migration (password)
	Migrated, // successfully migrated
	Error,    // misc error
	Exists,   // username already exists on the server
	TooMany,  // too many linked accounts
}

@Component({
	data () {
		return { LegacyState }
	},
})
export default class LegacyAccountCard extends Vue {
	@Prop() private name!: string
	@Prop() private acc!: any // TODO: make this an interface
	manage = false
	state = LegacyState.Init
	error = ""
	user = {
		name: this.acc.name,
		password: "",
	}

	async migrate () {
		const button = this.$refs.migrate as HTMLButtonElement

		button.disabled = true
		button.innerText = "Migrating..."

		const req = new Request(`${process.env.VUE_APP_API}/vault/legacy/account`, {
			method: "PATCH",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				accountId: this.acc["accountId"],
				username: this.user.name,
				password: this.user.password,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = LegacyState.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		if (Reflect.has(json, "accounts")) {
			this.$store.commit("setGameAccounts", json.accounts)
		} else if (Reflect.has(json, "account")) {
			this.$store.commit("pushGameAccount", json.account)
			this.$store.commit("setLegacyRevoltId", {
				revolt: json.account.accountId,
				legacy: this.acc.accountId,
			})
		}

		switch (rawResponse.status) {
		case 200:
			this.state = LegacyState.Migrated
			return
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 409:
			this.state = LegacyState.Exists
			break
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 416:
			this.state = LegacyState.TooMany
			break
		case 429:
			this.state = LegacyState.Error
			this.error = "Too many requests"
			return
		case 500:
			this.state = LegacyState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = LegacyState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = LegacyState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>

<style scoped>
.card {
	background: var(--main-1);
	box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2);
	margin: 0;
	padding: .8rem;
	display: flex;
	flex-direction: column;

	& .options {
		margin-top: auto;
	}

	& ul {
		padding: .7em;
		& li {
			font-family: monospace;
		}
	}

	& span {
		font-size: 1.2em;
	}

	& button {
		width: 100%;
	}
}
</style>
